package com.bocloud.cmp.controller;

import com.bocloud.cmp.entity.VolumePool;
import com.bocloud.cmp.service.VolumePoolService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Tag(name = "存储池信息管理")
public class VolumePoolController {

    @Autowired
    private VolumePoolService volumePoolService;

    @GetMapping(value = "/v1/storages/pools")
    @Operation(tags = "CMC", summary = "查询存储池列表")
    public GeneralResult<GridBean<VolumePool>> list(Pager pager) {
        return volumePoolService.list(pager);
    }
}
