package com.bocloud.cmp.domain;

import lombok.Data;

/**
 * 账号安全对象
 */
@Data
public class AccountSecurity {

    /**
     * ID
     */
    private Long id;
    /**
     * 目标对象id(用户，管理员，租户)
     */
    private Long targetId;
    /**
     * 随机数
     */
    private String salt;
    /**
     * apiKey
     */
    private String apiKey;
    /**
     * secKey
     */
    private String secKey;
    /**
     * 账号安全目标类型(Tenant,Manager,User)
     */
    private Category category;
    /**
     * 租户ID
     */
    private Long tenantId;

    public enum Category {
        /**
         * 租户
         */
        Tenant,
        /**
         * 用户
         */
        User,
        /**
         * 管理员
         */
        Manager,
    }

}
