package com.bocloud.cmp.domain;

import java.util.List;

import com.bocloud.cmp.enums.OrderItemStatus;
import com.megatron.common.model.RequestContext;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 退订参数
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年4月14日
 *
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class CancelationParam {

	/**
	 * 服务编码
	 */
	private String service;
	/**
	 * 服务编码
	 */
	private Long vendorId;
	/**
	 * 实例id
	 */
	private String instance;
	/**
	 * 服务类型
	 */
	private String category;
	/**
	 * 退订人
	 */
	private RequestContext context;
	/**
	 * 退订的机器
	 */
	private List<String> instances;
	/**
	 * 旧订单明细状态
	 */
	private OrderItemStatus oldStatus;

	private Boolean isDeletePublicIp;
}
