package com.bocloud.cmp.domain;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 订购信息数据模型
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年4月13日
 *
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class DurationModel {
	// 单位
	private Mode mode;
	// 时长
	private Integer amount;

	// 订购时间持续周期
	private Integer subscribeDuration;

	public enum Mode {
		/**
		 * 按小时
		 */
		HOUR,
		/**
		 * 按月
		 */
		MONTH,
		/**
		 * 按年
		 */
		YEAR
	}

	public DurationModel(Mode mode, Integer amount) {
		this.mode = mode;
		this.amount = amount;
	}
}
