package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 * 告警级别实体类
 * 
 * @author Shaolong_tan
 * @version 1.0
 * @since 2018年4月25日
 *
 */

@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("alarm_level")
public class AlarmLevel extends Generic {

	@PK(PKStrategy.AUTO)
	private Long id;// ID
	@Column("vendor_id")
	private Long vendorId;// 平台ID
	@Column("catalog")
	private String catalog;// 目标类别
	@Column("catalog_id")
	private Long catalogId;// 目标类别ID
	@Column("type")
	private String type;// 告警的类别：内存， cpu， ip池等 等
	@Column("alarm_mode")
	private String alarmMode;// 告警级别的模式： 使用百分比， 使用绝对值.默认使用百分比
	@Column("level1")
	private BigDecimal level1;// level1-level2 告警的阈值点
	@Column("level2")
	private BigDecimal level2;// level2-level3 告警的阈值点
	@Column("level3")
	private BigDecimal level3;// level3-level4 告警的阈值点
	@Column("level4")
	private BigDecimal level4;// level4-level5 告警的阈值点
	@Column("level_order")
	private String levelOrder;// 告警级别的升降序: ASCE, DESC. 默认ASCE

	@IgnoreAll
	private BigDecimal defaultLevel1; // level1 默认值

	@IgnoreAll
	private BigDecimal defaultLevel2; // level2 默认值

	@IgnoreAll
	private BigDecimal defaultLevel3; // level3 默认值

	@IgnoreAll
	private BigDecimal defaultLevel4; // level4 默认值

	public AlarmLevel(BigDecimal defaultLevel1, BigDecimal defaultLevel2) {
		super();
		this.defaultLevel1 = defaultLevel1;
		this.defaultLevel2 = defaultLevel2;
	}

}
