package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import java.util.Date;

/**
 * 对象存储元素实体类
 */
@Table("bucket_object")
public class BucketObject extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("object_key")
    private String key;
    @Column("size")
    private Long size; // 大小
    @Column("bucket_id")
    private Long bucketId;
    @Column("bucket_uuid")
    private Long bucketUuid; // 桶id
    @Column("upload_url")
    private String uploadUrl; // 用户上传的路径
    @Column("bucket_name")
    private String bucketName; // 容器名称
    @Column("vendor_id")
    private Long vendorId;
    @Column("tenant_id")
    private Long tenantId;
    @Column("type")
    private String type;
    @Column("is_directory")
    private Boolean isDirectory;
    @Column("parent_id")
    private Long parentId;
    @Column("object_acl")
    private String objectAcl;
    @IgnoreAll
    private String objectSize;

    @Column("object_user_id")
    private Long objectUserId;
    @Column("object_user_uuid")
    private Long objectUserUuid;
    @Column("object_user_name")
    private String objectUserName;

    @Column("absolute_path")
    private String absolutePath;
    @Column("parent_key")
    private String parentKey;
    @Column("last_modified")
    @com.fasterxml.jackson.databind.annotation.JsonSerialize(using = com.megatron.common.utils.DateSerializer.class)
    @com.fasterxml.jackson.databind.annotation.JsonDeserialize(using = com.megatron.common.utils.DateDeserializer.class)
    @org.springframework.format.annotation.DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastModified;
    @Column("object_index")
    private Integer objectIndex;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public Long getSize() {
        return size;
    }

    public void setSize(Long size) {
        this.size = size;
    }

    public Long getBucketId() {
        return bucketId;
    }

    public void setBucketId(Long bucketId) {
        this.bucketId = bucketId;
    }

    public String getUploadUrl() {
        return uploadUrl;
    }

    public void setUploadUrl(String uploadUrl) {
        this.uploadUrl = uploadUrl;
    }

    public String getBucketName() {
        return bucketName;
    }

    public void setBucketName(String bucketName) {
        this.bucketName = bucketName;
    }

    public Long getVendorId() {
        return vendorId;
    }

    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Boolean getIsDirectory() {
        return isDirectory;
    }

    public void setIsDirectory(Boolean isDirectory) {
        this.isDirectory = isDirectory;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    public String getObjectAcl() {
        return objectAcl;
    }

    public void setObjectAcl(String objectAcl) {
        this.objectAcl = objectAcl;
    }

    public String getObjectSize() {
        return objectSize;
    }

    public void setObjectSize(String objectSize) {
        this.objectSize = objectSize;
    }

    public Long getObjectUserId() {
        return objectUserId;
    }

    public void setObjectUserId(Long objectUserId) {
        this.objectUserId = objectUserId;
    }

    public String getObjectUserName() {
        return objectUserName;
    }

    public void setObjectUserName(String objectUserName) {
        this.objectUserName = objectUserName;
    }

    public Long getBucketUuid() {
        return bucketUuid;
    }

    public void setBucketUuid(Long bucketUuid) {
        this.bucketUuid = bucketUuid;
    }

    public Long getObjectUserUuid() {
        return objectUserUuid;
    }

    public void setObjectUserUuid(Long objectUserUuid) {
        this.objectUserUuid = objectUserUuid;
    }

    public String getAbsolutePath() {
        return absolutePath;
    }

    public void setAbsolutePath(String absolutePath) {
        this.absolutePath = absolutePath;
    }

    public String getParentKey() {
        return parentKey;
    }

    public void setParentKey(String parentKey) {
        this.parentKey = parentKey;
    }

    public Date getLastModified() {
        return lastModified;
    }

    public void setLastModified(Date lastModified) {
        this.lastModified = lastModified;
    }

    public Integer getObjectIndex() {
        return objectIndex;
    }

    public void setObjectIndex(Integer objectIndex) {
        this.objectIndex = objectIndex;
    }

}
