package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 字典实体类
 *
 * @author dmw
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Table("dictionary")
@EqualsAndHashCode(callSuper = true)
public class Dictionary extends Generic {
    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 父id
     */
    @Column("pid")
    private Long pid;
    /**
     * 字典名称
     */
    @Column("name")
    private String name;
    /**
     * 字典value
     */
    @Column("value")
    private String value;

    /**
     * 权重排序
     */
    @Column("weight")
    private Long weight = 1L;

    /**
     * 子集合
     */
    @IgnoreAll
    private List<Dictionary> children;

}
