package com.bocloud.cmp.entity;

import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Table("file_client_group")
public class FileClientGroup extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("vendor_id")
    private Long vendorId;
    @Column("tenant_id")
    private Long tenantId;
    @Column("client_gourp_uuid")
    private String clientGourpUuid;
    @Column("client_num")
    private Long clientNum;
    @Column("update_time")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
    @Column("create_time")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @IgnoreAll
    private Long fileClientGroupCount;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getVendorId() {
        return vendorId;
    }

    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    public String getClientGourpUuid() {
        return clientGourpUuid;
    }

    public void setClientGourpUuid(String clientGourpUuid) {
        this.clientGourpUuid = clientGourpUuid;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public Long getClientNum() {
        return clientNum;
    }

    public void setClientNum(Long clientNum) {
        this.clientNum = clientNum;
    }

    public Long getFileClientGroupCount() {
        return fileClientGroupCount;
    }

    public void setFileClientGroupCount(Long fileClientGroupCount) {
        this.fileClientGroupCount = fileClientGroupCount;
    }

}
