package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 网络与主机之间的关系表
 * 
 * @author weiwei
 * @since 2017.4.20
 *
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("network_host")
public class NetworkHost extends Generic {
	@PK(value = PKStrategy.AUTO)
	private Long id;
	@Column("network_id")
	private Long networkId;
	@Column("vhost_id")
	private Long vhostId;
	@Column("vendor_id")
	private Long vendorId;
	@Column("category")
	private String category;

	public NetworkHost(Long networkId, Long vhostId, Long vendorId, String category) {
		super();
		this.networkId = networkId;
		this.vhostId = vhostId;
		this.vendorId = vendorId;
		this.category = category;
	}
}
