package com.bocloud.cmp.entity;

import com.megatron.common.utils.DaySerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 组织机构-资源实体类
 * 
 * @author dongkai
 *
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("object_relation")
public class ObjectRelation extends Generic {

	@PK(value = PKStrategy.AUTO)
	private Long id; // ID
	@Column("target")
	private Long target; // 目标ID
	@Column("res_id")
	private Long resId; // 资源ID
	@Column("shared")
	private Boolean shared; // 是否共享
	@Column("category")
	private String category;// 资源类型
	@Column("catalog")
	private String catalog;// 目标类型
	@Column("used")
	private Boolean used = false; // 是否使用
	@Column
	private Integer size; // 大小
	@Column("expired_time")
	@JsonSerialize(using = DaySerializer.class)
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date expiredTime;// 过期时间

	public ObjectRelation(Long target, Long resId, Boolean shared, String category, String catalog, Integer size) {
		super();
		this.target = target;
		this.resId = resId;
		this.shared = shared;
		this.category = category;
		this.catalog = catalog;
		this.size = size;
	}

}
