package com.bocloud.cmp.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 物理机器类
 */
@Table("physical_server")
@Data
public class PhysicalServer extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id;

    @Column("region_id")
    private String regionId;

    @Column("zone_id")
    private String zoneId;

    @Column("vendor_id")
    private Long vendorId;

    @Column("resource_id")
    private String resourceId;

    @Column("instance_uuid")
    private String instanceUuid;

    @Column("device_uuid")
    private String deviceUuid;

    @Column("device_type")
    private String deviceType;

    @Column("name")
    private String name;

    @Column("remark")
    private String remark;

    @Column("system_volume_raid_id")
    private String systemVolumeRaidId;

    @Column("data_volume_raid_id")
    private String dataVolumeRaidId;

    @Column("image_uuid")
    private String imageUuid;

    @Column("os_type")
    private Long osType;

    @Column("os_type_name")
    private String osTypeName;

    @Column("vpc_uuid")
    private String vpcUuid;

    @Column("subnet_uuid")
    private String subnetUuid;

    @Column("private_ip")
    private String privateIp;

    @Column("public_ip")
    private String publicIp;

    @Column("ebm_state")
    private String ebmState;

    @Column("flavor")
    private String flavor;

    @Column("interfaces")
    private String interfaces;

    @Column("raid_detail")
    private String raidDetail;

    @Column("attached_volumes")
    private String attachedVolumes;

    @Column("device_detail")
    private String deviceDetail;

    @Column("freezing")
    private Boolean freezing;

    @Column("expired")
    private Boolean expired;

    @Column("create_time")
    private String createTime;

    @Column("updated_time")
    private String updatedTime;

    @Column("delete_time")
    private String deleteTime;

    @Column("expired_time")
    private String expiredTime;

    @Column("on_demand")
    private Boolean onDemand;

    @Column("gmt_create")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;

    @Column("gmt_modify")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;

    @Column("creator_id")
    private Long creatorId;

    @Column("mender_id")
    private Long menderId;

    @Column("tenant_id")
    private Long tenantId;

    @Column("project_id")
    private Long projectId;

    @Column("is_deleted")
    private Boolean isDeleted;

    @Column("display_name")
    private String displayName;

    @IgnoreAll
    private String hostname;

    @IgnoreAll
    private String extIp;

    @IgnoreAll
    private String password;

    @IgnoreAll
    private String vpcName;

    @IgnoreAll
    private String subnetName;

    @IgnoreAll
    private String zoneName;

    @IgnoreAll
    private Long cycleCount;

    @IgnoreAll
    private String cycleType;

    @IgnoreAll
    private Long orderCount;

}
