package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Table("resource_protocol")
public class ResourceProtocol extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("resource_id")
    private Long resourceId; // 资源id
    @IgnoreAll
    @Column("resource_name")
    private String resourceName; // 资源名称
    @Column("protocol")
    private String protocol; // 协议
    @Column("port")
    private Integer port; // 端口
    @Column("edit_vnc_password")
    private Boolean editVncPassword;
    @Column("has_vnc_password")
    private Boolean hasVncPassword;

}
