package com.bocloud.cmp.entity;

import com.alibaba.fastjson.JSON;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Table("resource_type")
public class ResourceType extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("uuid")
    private String uuid; // uuid
    @Column("vendor_id")
    private Long vendorId; // vendorId
    @Column("privilege_account")
    private String privilegeAccount;//超级管理员账号
    @Column("gui")
    private String gui;// 图形协议，一般包括xdmcp,xfwd,vnc,
    @Column("term")
    private String term;// 字符终端协议，一般包括telnet、ssh
    @Column("file")
    private String file;// 文件传输协议，一般包括telnet、ssh
    @Column("connect_client")
    private String connectClient;// 连接客户端, 如oracle一般包括sqlplusw,sqldeveloperW,SqlDbx,Toad,plsqldev, oem
    @Column("type")
    private String type;// Unix, Database, Application, Linux, Network, Main Frame, Windows, Windows Domain
    @Column("charsets")
    private String charsets;// IBM1388
    @Column("service_config")
    private String serviceConfig;// 系统配置

    public List<String> getProtocols() {
        List<String> protocols = new ArrayList<>();
        protocols.addAll(Optional.ofNullable(this.gui).map(o -> JSON.parseArray(o, String.class)).orElseGet(ArrayList::new));
        protocols.addAll(Optional.ofNullable(this.term).map(o -> JSON.parseArray(o, String.class)).orElseGet(ArrayList::new));
        protocols.addAll(Optional.ofNullable(this.file).map(o -> JSON.parseArray(o, String.class)).orElseGet(ArrayList::new));
        return protocols;
    }
}
