package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import java.util.List;

/**
 * 光纤交换机zone
 *
 * @author luyanchao
 * @since 2019/6/5 14:28
 */
@Table("san_fabric_zone")
public class SanFabricZone extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("fabric_id")
    private Long fabricId; // 所属光纤交换机id
    @Column("type")
    private String type; // 所属光纤交换机type
    @IgnoreAll
    private List<SanFabricZoneMember> members; // members
    @IgnoreAll
    private String fabricName;// fabric name
    @Column("vsan_id")
    private Long vsanId;
    @IgnoreAll
    private List<Long> portIds;
    @IgnoreAll
    private List<Long> zoneSetIds;
    @Column("vsan_name")
    @IgnoreAll
    private String vsanName;
    @IgnoreAll
    private Integer portSize;
    @IgnoreAll
    private Integer aliasSize;
    @IgnoreAll
    private Integer wwnSize;
    @IgnoreAll
    private List<Long> zonesForAlias;
    @IgnoreAll
    private String zoneSet;

    public SanFabricZone() {
        super();
    }

    public SanFabricZone(Long fabricId, String name, List<SanFabricZoneMember> members) {
        this.fabricId = fabricId;
        this.setName(name);
        this.members = members;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getFabricId() {
        return fabricId;
    }

    public void setFabricId(Long fabricsId) {
        this.fabricId = fabricsId;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public List<SanFabricZoneMember> getMembers() {
        return members;
    }

    public void setMembers(List<SanFabricZoneMember> members) {
        this.members = members;
    }

    public String getFabricName() {
        return fabricName;
    }

    public void setFabricName(String fabricName) {
        this.fabricName = fabricName;
    }

    public Long getVsanId() {
        return vsanId;
    }

    public void setVsanId(Long vsanId) {
        this.vsanId = vsanId;
    }

    public List<Long> getPortIds() {
        return portIds;
    }

    public void setPortIds(List<Long> portIds) {
        this.portIds = portIds;
    }

    public List<Long> getZoneSetIds() {
        return zoneSetIds;
    }

    public void setZoneSetIds(List<Long> zoneSetIds) {
        this.zoneSetIds = zoneSetIds;
    }

    public String getVsanName() {
        return vsanName;
    }

    public void setVsanName(String vsanName) {
        this.vsanName = vsanName;
    }

    public Integer getPortSize() {
        return portSize;
    }

    public void setPortSize(Integer portSize) {
        this.portSize = portSize;
    }

    public List<Long> getZonesForAlias() {
        return zonesForAlias;
    }

    public void setZonesForAlias(List<Long> zonesForAlias) {
        this.zonesForAlias = zonesForAlias;
    }

    public Integer getAliasSize() {
        return aliasSize;
    }

    public void setAliasSize(Integer aliasSize) {
        this.aliasSize = aliasSize;
    }

    public Integer getWwnSize() {
        return wwnSize;
    }

    public void setWwnSize(Integer wwnSize) {
        this.wwnSize = wwnSize;
    }

    public String getZoneSet() {
        return zoneSet;
    }

    public void setZoneSet(String zoneSet) {
        this.zoneSet = zoneSet;
    }
}
