package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 云主机与ISO镜像关系类
 * 
 * @author luyancaho
 * @date 2021年9月14日
 */
@Data
@NoArgsConstructor
@Table("server_image")
public class ServerImage extends Generic {

	@PK(value = PKStrategy.AUTO)
	private Long id;// ID
	@Column("server_id")
	private Long serverId;// 云主机ID
	@Column("image_id")
	private Long imageId;// 云硬盘ID
	@Column("boot_index")
	private Integer bootIndex; // 启动顺序
	@Column("bus")
	private String bus; // 总线
	@Column("disabled")
	private Boolean disabled; // 停用
	@Column("diff_key")
	private Long diffKey;
}
