package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

/**
 * 快照组实体类
 */
@Table("snapshot_group")
public class SnapshotGroup extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("vendor_id")
    private Long vendorId;
    @Column("uuid")
    private String uuid;
    @Column("storage_synced_set_id")
    private Long syncedSetId; // 一致性组关联的一致性组
    @IgnoreAll
    private Integer snapshotCount;
    @Column("synced_set_name")
    @IgnoreAll
    private String syncedSetName; // 一致性组关联的一致性组

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getVendorId() {
        return vendorId;
    }

    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public Long getSyncedSetId() {
        return syncedSetId;
    }

    public void setSyncedSetId(Long syncedSetId) {
        this.syncedSetId = syncedSetId;
    }

    public Integer getSnapshotCount() {
        return snapshotCount;
    }

    public void setSnapshotCount(Integer snapshotCount) {
        this.snapshotCount = snapshotCount;
    }

    public String getSyncedSetName() {
        return syncedSetName;
    }

    public void setSyncedSetName(String syncedSetName) {
        this.syncedSetName = syncedSetName;
    }
}
