package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 存储服务器
 *
 * @author luyanchao
 * @since 2019/1/25 13:48
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Table("storage")
public class Storage extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("vendor_id")
    private Long vendorId; // 云供应商ID
    @Column("uuid")
    private String uuid; // 唯一标识
    @Column("ip")
    private String ip; // ip地址
    @Column("port")
    private Integer port; // 端口
    @Column("host")
    private String host; // 主机名
    @Column("username")
    private String username; // 主机名
    @Column("password")
    private String password; // 主机名
    @Column("type")
    private String type; // 存储类型

    @Column("total_capacity")
    private Double totalCapacity; // 总容量
    @Column("used_capacity")
    private Double usedCapacity; // 已用容量
    @Column("free_capaticy")
    private Double freeCapaticy; // 可用容量

    @Column("hdd_total_capacity")
    private Double hddTotalCapacity; // hdd总容量
    @Column("hdd_used_capacity")
    private Double hddUsedCapacity; // hdd已用容量
    @Column("hdd_free_capaticy")
    private Double hddFreeCapaticy; // hdd可用容量

    @Column("ssd_total_capacity")
    private Double ssdTotalCapacity; // ssd总容量
    @Column("ssd_used_capacity")
    private Double ssdUsedCapacity; // ssd已用容量
    @Column("ssd_free_capaticy")
    private Double ssdFreeCapaticy; // ssd可用容量

    @Column("mdisk_capacity")
    private Double mdiskCapacity; // mdisk中容量
    @Column("pool_capacity")
    private Double poolCapacity; // 存储池中容量
    @Column("vdisk_capacity")
    private Double vdiskCapacity; // 分配给卷的容量
    @Column("vdisk_total_capacity")
    private Double vdiskTotalCapacity; // 存储卷总容量
    @Column("vdisk_copy_capacity")
    private Double vdiskCopyCapacity; // 存储卷拷贝容量
    @Column("over_allocation")
    private Integer overAllocation; // 总超量分配百分比
    @Column("pool_name")
    private String poolName;

    @Column("compression_suppoerd")
    private Boolean compressionSuppoerd; // 是否支持压缩
    @Column("default_template_id")
    private Long defaultTemplateId; // 默认存储器模板id
    @Column("default_template_uuid")
    private String defaultTemplateUuid; // 默认存储器模板id
    @IgnoreAll
    private com.bocloud.cmp.entity.VolumePool volumePool; // 存储池的信息
    @Column("identifier")
    private String identifier; // 系统标识
    @Column("code_version")
    private String codeVersion; // 软件版本
    @Column("storage_uuid")
    private String storageUuid; // 唯一标识
    @Column("key_path")
    private String keyPath; // smis传参用
    @Column("operational_status")
    private String operationalStatus; // 运行状态
    @Column("sn")
    private String sn; // 序列号
    @Column("version")
    private String version; // 设备版本
    @IgnoreAll
    private Integer diskAllCount; // 总硬盘数量
    @IgnoreAll
    private Integer diskUseCount; // 已用硬盘数量
    @IgnoreAll
    private Double diskCapacity; // disk中容量
    /**
     * 监控相关
     */
    @IgnoreAll
    private Long ruleRelationId;// 资源告警规则关联关系id
    @IgnoreAll
    private String thresholdGroupName;// 阈值组名称
    @IgnoreAll
    private String policyName;// 分发策略名称
    @IgnoreAll
    private Long thresholdGroupId;  //阈值组ID
    @IgnoreAll
    private Long policyId; //分发策略ID

    @Column("discovery_username")
    private String discoveryUsername; // iSCSI客户端发现时需要填写的用户名
    @Column("discovery_password")
    private String discoveryPassword; // iSCSI客户端发现时需要填写的密码
    @Column("discovery_encrypted")
    private Boolean discoveryEncrypted; // iSCSI客户端发现时需要填写的密码是否加密
    @Column("discovery_chap")
    private Boolean discoveryChap; // iSCSI客户端发现时是否使用双向认证
    @Column("discovery_mutual_username")
    private String discoveryMutualUsername; // iSCSI客户端用户名
    @Column("discovery_mutual_password")
    private String discoveryMutualPassword; // iSCSI客户端密码
    @Column("discovery_mutual_encrypted")
    private Boolean discoveryMutualEncrypted; // iSCSI客户端密码是否加密


}
