package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

/**
 * 存储一致性组
 */
@Table("storage_synced_set")
public class StorageSyncedSet extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // id
    @Column("storage_id")
    private Long storageId; // 集群id
    @Column("synced_set_uuid")
    private String syncedSetUuid; // 标识
    @Column("type")
    private String type; // 复制的类型
    @Column("key_path")
    private String keyPath; // smis传参用
    @Column("vendor_id")
    private Long vendorId;
    @Column("snapshot_group_id")
    private Long snapshotGroupId; // 一致性组关联快照id
    @IgnoreAll
    private Long snapshotGroupCount;
    @IgnoreAll
    private Long volumeCount;

    public String getKeyPath() {
        return keyPath;
    }

    public void setKeyPath(String keyPath) {
        this.keyPath = keyPath;
    }

    public StorageSyncedSet() {
        super();
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getStorageId() {
        return storageId;
    }

    public void setStorageId(Long storageId) {
        this.storageId = storageId;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getSyncedSetUuid() {
        return syncedSetUuid;
    }

    public void setSyncedSetUuid(String syncedSetUuid) {
        this.syncedSetUuid = syncedSetUuid;
    }

    public Long getVendorId() {
        return vendorId;
    }

    public void setVendorId(Long vendorId) {
        this.vendorId = vendorId;
    }

    public Long getSnapshotGroupId() {
        return snapshotGroupId;
    }

    public void setSnapshotGroupId(Long snapshotGroupId) {
        this.snapshotGroupId = snapshotGroupId;
    }

    public Long getSnapshotGroupCount() {
        return snapshotGroupCount;
    }

    public void setSnapshotGroupCount(Long snapshotGroupCount) {
        this.snapshotGroupCount = snapshotGroupCount;
    }

    public Long getVolumeCount() {
        return volumeCount;
    }

    public void setVolumeCount(Long volumeCount) {
        this.volumeCount = volumeCount;
    }
}
