package com.bocloud.cmp.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreUpdate;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 系统设置的类
 *
 * @author lyy
 * @Version 1.0
 * @since 2017年8月18日
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("system_config")
public class SystemConfig extends Generic {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 配置编码
     */
    @Column("code")
    private String code;
    /**
     * 配置名称
     */
    @Column("name")
    private String name;
    /**
     * 配置值
     */
    @Column("value")
    private String value;
    /**
     * 配置注释
     */
    @Column("remark")
    private String remark;
    /**
     * 配置分类
     */
    @Column("category")
    private String category;

    /**
     * 配置子类
     */
    @Column("subclass")
    private String subclass;
    /**
     * 配置类型（TEXT、SELECTICON、PASSWORD）
     */
    @Column("type")
    private String type;
    /**
     * 配置json串
     */
    @Column("config")
    private String config;
    /**
     * 创建人id
     */
    @Column("creator_id")
    private Long creatorId;
    /**
     * 修改人Id
     */
    @Column("mender_id")
    private Long menderId;
    /**
     * 创建时间
     */
    @Column("gmt_create")
    @IgnoreUpdate
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    /**
     * 修改时间
     */
    @Column("gmt_modify")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;
}
