package com.bocloud.cmp.entity;

import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreUpdate;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Table("tag")
public class Tag extends Generic {
	@PK(value = PKStrategy.AUTO)
	private Long id;
	@Column("tag_key")
	private String key;
	@Column("resource_id")
	private String resourceId;
	@Column("resource_type")
	private String resourceType;
	@Column("tag_value")
	private String value;
	@Column("vendor_id")
	private Long vendorId;
	@IgnoreUpdate
	@Column(value = "gmt_create", nullable = false)
	@JsonSerialize(using = DateSerializer.class)
	@JsonDeserialize(using = DateDeserializer.class)
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date gmtCreate;
	@Column("gmt_modify")
	@JsonSerialize(using = DateSerializer.class)
	@JsonDeserialize(using = DateDeserializer.class)
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date gmtModify;
	@Column("region_id")
	private String regionId;// 所属域
	@Column("tag_uuid")
	private String tagUuid; // 标签唯一标识，key_value

	public Tag(String key, String value, String resourceId) {
		super();
		this.key = key;
		this.value = value;
		this.resourceId = resourceId;
	}

	public Tag(String key, String value, String resourceId, String resourceType) {
		super();
		this.key = key;
		this.value = value;
		this.resourceId = resourceId;
		this.resourceType = resourceType;
	}
}