package com.bocloud.cmp.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;


/**
 * 存储卷数据拷贝
 *
 * @author luyanchao
 */
@Table("volume_mirror")
public class VolumeMirror extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; //
    @Column("volume_id")
    private Long volumeId; // 所属存储卷id
    @Column("pool_id")
    private Long poolId; // 所属存储池id
    @Column("pool_name")
    @IgnoreAll
    private String poolName; // 所属存储池名称
    @Column("mirror_uuid")
    private String mirrorUuid; // 唯一标识
    @Column("key_path")
    private String keyPath; // smis传参
    @Column("used_capacity")
    private Long usedCapacity; // 已用容量byte
    @Column("real_capacity")
    private Long realCapacity; // 实际容量byte
    @Column("type")
    private String type; // 类型
    @Column("fast_write_state")
    private String fastWriteState; // 快速写入状态
    @Column("warning")
    private Integer warning; // 告警阈值0-100
    @Column("grain_size")
    private Integer grainSize; // 自动精简配置颗粒度
    @Column("auto_expand")
    private Boolean autoExpand; // 是否自动扩展
    @Column("major")
    private Boolean major; // 是否主拷贝
    @Column("copy_synced")
    private Boolean copySynced; // 是否拷贝完成
    @Column("is_space_efficient")
    private Boolean isSpaceefficient; // 是否高效

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getVolumeId() {
        return volumeId;
    }

    public void setVolumeId(Long volumeId) {
        this.volumeId = volumeId;
    }

    public Long getPoolId() {
        return poolId;
    }

    public void setPoolId(Long poolId) {
        this.poolId = poolId;
    }

    public String getPoolName() {
        return poolName;
    }

    public void setPoolName(String poolName) {
        this.poolName = poolName;
    }

    public String getMirrorUuid() {
        return mirrorUuid;
    }

    public void setMirrorUuid(String mirrorUuid) {
        this.mirrorUuid = mirrorUuid;
    }

    public String getKeyPath() {
        return keyPath;
    }

    public void setKeyPath(String keyPath) {
        this.keyPath = keyPath;
    }

    public Long getUsedCapacity() {
        return usedCapacity;
    }

    public void setUsedCapacity(Long usedCapacity) {
        this.usedCapacity = usedCapacity;
    }

    public Long getRealCapacity() {
        return realCapacity;
    }

    public void setRealCapacity(Long realCapacity) {
        this.realCapacity = realCapacity;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getFastWriteState() {
        return fastWriteState;
    }

    public void setFastWriteState(String fastWriteState) {
        this.fastWriteState = fastWriteState;
    }

    public Integer getWarning() {
        return warning;
    }

    public void setWarning(Integer warning) {
        this.warning = warning;
    }

    public Integer getGrainSize() {
        return grainSize;
    }

    public void setGrainSize(Integer grainSize) {
        this.grainSize = grainSize;
    }

    public Boolean getAutoExpand() {
        return autoExpand;
    }

    public void setAutoExpand(Boolean autoExpand) {
        this.autoExpand = autoExpand;
    }

    public Boolean getMajor() {
        return major;
    }

    public void setMajor(Boolean major) {
        this.major = major;
    }

    public Boolean getCopySynced() {
        return copySynced;
    }

    public void setCopySynced(Boolean copySynced) {
        this.copySynced = copySynced;
    }

    public Boolean getIsSpaceefficient() {
        return isSpaceefficient;
    }

    public void setIsSpaceefficient(Boolean spaceefficient) {
        isSpaceefficient = spaceefficient;
    }
}
