package com.bocloud.cmp.enums;

/**
 * 子订单状态
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月14日
 */
public enum OrderItemStatus {
	/*
	 * 开通成功
	 */
	OpenedSuccess,
	/**
	 * 开通失败
	 */
	OpenedFailure,
	/**
	 * 正在开通
	 */
	Opening,
	/**
	 * 变更成功
	 */
	ChangeSuccess,
	/**
	 * 变更失败
	 */
	ChangeFailure,
	/**
	 * 正在变更
	 */
	Changing,
	/**
	 * 退订成功
	 */
	UnsubscribeSuccess,
	/**
	 * 退订失败
	 */
	UnsubscribeFailure,
	/**
	 * 正在退订
	 */
	Unsubscribing,
	/**
	 * 延期成功
	 */
	ExtensionSuccess,
	/**
	 * 延期失败
	 */
	ExtensionFailure,
	/**
	 * 延期中
	 */
	Extensioning,
	/**
	 * 已废弃
	 */
	Abandoned,
	/**
	 * 已取消
	 */
	Canceld,
	/**
	 * 已终止
	 */
	Termination,
	/**
	 * 待审批
	 */
	Audit

}
