package com.bocloud.cmp.internal;


import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.boot.model.BocloudToken;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.License;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.core.Service;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.framework.http.core.ServiceFactory;
import com.megatron.framework.http.model.RemoteService;
/**
 * 获取license
 * @author hp
 *
 */
@Component
public class SmsLicenseService implements InitializingBean {

	@Autowired
	private ServiceFactory serviceFactory;
	@Autowired
	private CurrentService currentService;
	private static Service service = Service.create("sms");
	private Map<String, Object> headers = new HashMap<>(4);

	public License getLicense() {
		RemoteService remoteService = serviceFactory.build(service, "/v1/config/license",
				HttpMethod.GET, headers, null);
		GeneralResult result = remoteService.invoke();
		if (result.isFailed()) {
			return null;
		}
		String data = JSONObject.toJSONString(result.getData());
		return JSONObject.parseObject(data, License.class);
	}


	@Override
	public void afterPropertiesSet() throws Exception {
		this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
		this.headers.put("source", currentService.getService().getName());
	}
}
