package com.bocloud.cmp.model;

import lombok.Data;

import java.util.List;

@Data
public class ClusterModel {
    private String name;
    private Long cpuTotal;
    private Double memTotal;
    private Double diskTotal;
    private Long cpuUsed;
    private Double memUsed;
    private Double diskUsed;
    private List<HostModel> hosts;
    private Integer hostNum;// 集群中宿主机数量
    private Integer vmNum;// 集群中云主机数量
    private Integer templateNum;// 集群中模板数量
    private Integer cpuCore; // 集群中cpu核数
    private String remark; // 描述
    private String clusterVal;
    private String version;
    private String vdcUuid;
    private String status;
    private List<PoolModel> pools;
    private String uuid;
    private ResourcePoolModel resourcePool;// 资源池
    private String region;
    private List<String> hostNames;
    private List<String> policies;
    private String initialPolicy; // 布置策略
    private Integer cpu;
    private String zone;
    private Integer disk;
    private Integer memory;
    private String service;

    //-----FusionSphere新增字段--------//
    private String uri;//访问该cluster对应的uri地址
    private String arch;//集群架构，x86场景为“x86”，arm场景下为“arm”
    private String parentObjUrn;//父目录标识，若直接位于站点下则为空
    private Boolean isMemOvercommit;//内存复用开关
    private Boolean isEnableHa;//HA功能开关 (创建需要传递)
    private String resStrategy;//集群的资源分配策略 loadBalance: 负载均衡、random: 随机、默认是负载均衡
    private Boolean isEnableImc;//异构迁移集群(IMC)模式开关\true: 开启\false: 关闭
    private Boolean isEnableDrs;//DRS开关
    private Boolean enableGuestNuma;//集群非统一内存访问开关（NUMA）
    private Boolean enableIoTailor;//集群本地内存盘开关
    private Boolean isAutoAdjustNuma;//可选，是否开启NUMA结构自动调整
    private String vdcUri;
    //非重要参数，可以舍弃，不涉及到业务逻辑
    private String tags;//集群标签
    private String parentObjName;//集群所在文件夹名称
    private Boolean enableHostNumaDRS;//hostNumaDrs开关
    private String imcSetting;//可选，异构迁移集群(IMC)模式设置Baseline值。当参数isEnableImc为true时为必选参数；当参数isEnableImc为false或为空时，忽略此参数。可设置Intel系列CPU 10个(不支持AMD系列CPU)“Nehalem”，“Westmere”，“Sandy Bridge”，“Ivy Bridge”，“Haswell-noTSX”,“Haswell”， “Broadwell-noTSX”,“Broadwell”, “Skylake-Client”, “Skylake-Server”。后一个Baseline兼容前一个。
    private Boolean highPerformance;//高性能集群开关
    private Boolean enableVmDrs;//可选，是否开启云主机个别设置。
    //-----FusionSphere新增字段--------//


    /**
     * @param name
     * @param cpuTotal
     * @param memTotal
     * @param diskTotal
     * @param cpuUsed
     * @param memUsed
     * @param diskUsed
     * @param hosts
     */
    public ClusterModel(String name, Long cpuTotal, Double memTotal, Double diskTotal, Long cpuUsed, Double memUsed,
                        Double diskUsed, List<HostModel> hosts, Integer hostNum, Integer vmNum, Integer templateNum,
                        Integer cpuCore, String clusterVal) {
        this.name = name;
        this.cpuTotal = cpuTotal;
        this.memTotal = memTotal;
        this.diskTotal = diskTotal;
        this.cpuUsed = cpuUsed;
        this.memUsed = memUsed;
        this.diskUsed = diskUsed;
        this.hosts = hosts;
        this.hostNum = hostNum;
        this.vmNum = vmNum;
        this.templateNum = templateNum;
        this.cpuCore = cpuCore;
        this.clusterVal = clusterVal;
    }

    /**
     *
     */
    public ClusterModel() {
        super();
    }

}
