package com.bocloud.cmp.model;

import lombok.Data;

import java.util.List;

@Data
public class DataStoreModel {
    private String name;// 存储名称
    private String type;// 存储类型
    private String path;// 存储路径
    private Double capacity;// 容量大小
    private Double freeSpace;// 可用容量
    private Integer hostNum;// 存储下管理主机数量
    private Integer vmNum;// 存储下管理云主机数量
    private Integer templateNum;// 存储下模板的数量
    private String storeVal;
    private String status;
    private List<ImageModel> images;
    private List<DataStoreFileModel> files; // 数据中心里的文件
    private String hostName;// 主机名称
    private String accessMode;
    private String remoteHost;// 服务器
    private String remotePath;// 服务器文件夹路径
    private String scId;
    private String userName;
    private String password;
    private String remoteHostNames;
    private String vdcName;
    private Long hostId;
    private ClusterModel cluster;

    //fc 纳管
    private String uri;//访问主机的uri
    private String storeDeviceUuid;
    private String remark;
    private String vdcUri;
    private String hostUuid;
    private Integer useType;//必选。设备使用方式
    private List<String> hostUuids; //数据存储挂接的主机URN。
    //fc 纳管


    public DataStoreModel(String name, String type, String path, Double capacity, Double freeSpace, Integer hostNum,
                          Integer vmNum, Integer templateNum, String storeVal) {
        this.name = name;
        this.type = type;
        this.path = path;
        this.capacity = capacity;
        this.freeSpace = freeSpace;
        this.hostNum = hostNum;
        this.vmNum = vmNum;
        this.templateNum = templateNum;
        this.storeVal = storeVal;
    }

    /**
     *
     */
    public DataStoreModel() {
        super();
    }

}
