package com.bocloud.cmp.model;

import lombok.Data;

import java.util.List;

@Data
public class HostModel {
	private Long id;
	private String name;
	private String uuid;
	private Long cpuHz;
	private Integer cpuNum;// 宿主机（物理机）cpu数量
	private Integer cpuCore;// 宿主机cpu核数
	private Long cpuTotal;
	private String cpuVendor;
	private Double memTotal;
	private Double memSwap;
	private Double diskTotal;
	private Long cpuUsed;
	private Double cpuUsedRate;
	private Double memUsed;
	private Double memReserved; // 保留内存
	private Double memUsedRate;
	private Double diskUsed;
	private String clusterUuid;
	private String category;
	private String catalog;
	private String osCategory;
	private String os;
	private String osName;
	private String osVersion;
	private String kernelVersion;
	private String cpuModel;
	private String vendor;
	private List<String> stores;
	private Integer vmNum;// 宿主机（物理机）上云主机数量
	private String powerState;// 宿主机（物理机）电源状态
	private Integer templateNum;
	private List<ServerModel> servers;// 云主机
	private Integer datastoreNum; // 宿主机（物理机）存储数量
	private String hostIp;
	private String serviceIp;
	private String status;
	private List<NetworkCardModel> netcards;// 宿主机（物理机）上的物理网卡
	private Boolean maintained;// 宿主机（物理机）是否处于维护模式
	private Boolean connected;// 宿主机是否处于连接状态
	private String hostName;
	private List<DataStoreModel> dataStores;
	private List<NetworkModel> networks;
	private List<SwitchModel> switchers;
	private ResourcePoolModel resourcePool;
	private List<String> hmcUuids;
	private Double hmcCpu; // cmp单元数，适用于Hmc和Powervc
	private Double hmcCpuReserved; // 保留cpu单元数，适用于Hmc和Powervc
	private Double hmcCpuUsed; // 正在使用cpu单元数，适用于Hmc和Powervc
	private Boolean ipv6Enabled;
	private String evc;// evc信息
	private String assignedLicense;// license信息
	private String esxVersion;// esx版本
	private String vmotionIp;// vmotionIp
	private String role; // 角色
	private Long clockDiff; // 服务器时间差，毫秒
	private String props;
	private String services; // 主机上运行的服务
	private String cephVersion; // CEPH版本
	private String ipmiAddress;
	private String ipmiAccount;
	private String ipmiPassword;
	private String ipmiPort;
	private StorageDiskModel rootDisk; // 系统盘
	private List<StorageDiskModel> disks; // 所有磁盘
	private Integer gatewayPort; // 网关服务端口
	private String gatewayUsername; // 网关服务用户名
	private String gatewayPassword; // 网关服务密码
	private List<ScsiLunModel> scsiLunModels;
	private String modelName;

	private Long diskTotalSizeByte;
	private Long diskUsedSizeByte;
	private Long diskCacheSizeByte;
	private Integer hddCount;
	private Integer ssdCount;
	private Long hddTotalSizeByte;
	private Long ssdTotalSizeByte;


	/**
     *
     */
	public HostModel() {
		super();
	}

	/**
	 * @param name
	 * @param uuid
	 * @param cpuNum
	 * @param cpuCore
	 * @param cpuTotal
	 * @param memTotal
	 * @param diskTotal
	 * @param cpuUsed
	 * @param memUsed
	 * @param diskUsed
	 * @param category
	 * @param catalog
	 * @param cpuModel
	 * @param vendor
	 * @param stores
	 * @param vmNum
	 * @param powerState
	 * @param templateNum
	 * @param servers
	 * @param datastoreNum
	 * @param hostIp
	 * @param status
	 * @param netcards
	 * @param maintained
	 * @param connected
	 */
	public HostModel(String name, String uuid, Integer cpuNum, Integer cpuCore, Long cpuTotal, Double memTotal,
			Double diskTotal, Long cpuUsed, Double memUsed, Double diskUsed, String category, String catalog,
			String cpuModel, String vendor, List<String> stores, Integer vmNum, String powerState, Integer templateNum,
			List<ServerModel> servers, Integer datastoreNum, String hostIp, String status,
			List<NetworkCardModel> netcards, Boolean maintained, Boolean connected) {
		super();
		this.name = name;
		this.uuid = uuid;
		this.cpuNum = cpuNum;
		this.cpuCore = cpuCore;
		this.cpuTotal = cpuTotal;
		this.memTotal = memTotal;
		this.diskTotal = diskTotal;
		this.cpuUsed = cpuUsed;
		this.memUsed = memUsed;
		this.diskUsed = diskUsed;
		this.category = category;
		this.catalog = catalog;
		this.cpuModel = cpuModel;
		this.vendor = vendor;
		this.stores = stores;
		this.vmNum = vmNum;
		this.powerState = powerState;
		this.templateNum = templateNum;
		this.servers = servers;
		this.datastoreNum = datastoreNum;
		this.hostIp = hostIp;
		this.status = status;
		this.netcards = netcards;
		this.maintained = maintained;
		this.connected = connected;
	}

}
