package com.bocloud.cmp.model;

import lombok.Data;

@Data
public class NetcardOperation {
	private String name;
	private String model;
	private String operation;
	private String type;
	private String label;
	private String portType;// 端口类型
	private Long ciscoSubnetId;// 思科sdn下subnet的ID
	private IpModel ip;// 网卡分配的IP
	private String mac;// 已存在的网卡mac地址
	private String address;// 用户指定的IP
	private boolean ipv6Enabled;
	private String ipv6Address;
	private IpModel ipv6;
	private Long vpcId;// 从nsx获取
	private Long networkCardId;// 网卡id
	private String networkCardUuid; // 网卡uuid
	private Long networkId;// 网络id
	private String networkUuid; // 网络uuid
	private Long subnetId;// 子网id
	private Long ipPoolId;// IP池ID
	private Long ipId;// 手动选择的IP地址
	private String link; // up or down
	private String ovs;
	private Integer vlan;
	private String ipPolicy;
	private String action;

	private Long vswitchId;
	private String vswitchUuid;
	private String vswitchName;

	private Long ipv4PoolId;
	private Long ipv6PoolId;

	// fc 纳管
	private Integer sequenceNum;
	// fc 纳管

	public NetcardOperation() {
		super();
	}

	public NetcardOperation(String name, String label) {
		super();
		this.name = name;
		this.label = label;
	}

	public NetcardOperation(String name, String operation, String type, String label) {
		super();
		this.name = name;
		this.operation = operation;
		this.type = type;
		this.label = label;
	}

}
