package com.bocloud.cmp.model;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 物理网卡
 *
 * @author songsong
 */
@Data
public class NetworkCardModel {
    private String name;// 物理网卡的名称
    private String mac;// 物理网卡mac值
    private Boolean used;// 网卡在某一台物理机上是否被使用
    private String label;// 标签
    private String switcher;
    private String portType;// 端口类型
    private String zone;
    private String regionId;
    private String vpcUuid;
    private Long networkId;
    private String networkUuid;
    private String subnetUuid;
    private String ipAddress;
    private String netmask;
    private String gateway;
    private Integer vlan;
    private List<JSONObject> privateIpAddressSet; // 指定网卡内网信息
    private Date gmtCreate;
    private String networkcardUuid;
    private String remark;
    private Boolean isPrimary;
    private String status;
    private String instanceId;
    private List<String> securityGroupIds;
    private String floatingIpUuid;//eip uuid
    private String ovsbrName; // ovs网桥名称
    private Boolean switcherAvailable;
    private String link;
    private String model;
    private String operation;
    private Integer mtu;
    private Long speed;
    private Boolean dhcp; // 是否开启dhcp

    //fc 纳管
    private String uri;
    private String portGroupUuid;
    private String type;
    private Integer sequenceNum;//网卡对应的总线编号
    private  Boolean enableSecurityGroup;//云主机网卡是否开启安全组
    private String securityGroupUuid;//安全组Id
    private Integer vringbuf;//IO环大小，默认为256，取值范围为256、512、1024、2048、4096
    private Integer queues;//队列数，默认为1，取值范围为[1,8]
    private String serverUri;//云主机uri
    //fc 纳管
}
