package com.bocloud.cmp.model;

import lombok.Data;

import java.util.List;

@Data
public class PortGroupModel {
    private String name;
    private String oldName;
    private String type;
    private Integer portNum;
    private String groupVal;
    private String remark;
    private Integer vlanId;
    private String trunkVlan;// 中继vlan
    private String vlanType;
    private Long switcherId;
    private String switcherName;
    private Long hostId;
    private String vdcName;
    private NetworkModel networkModel;
    private Boolean allowPromiscuous;// 是否接受混杂模式
    private Boolean macChanges;// 是否接受mac地址更改
    private Boolean forgedTransmits;// 是否接受伪传输
    private Boolean inTrafficEnabled;// 是否启用输入流量调整
    private Long inAverageBandWidth;// 输入流量平均带宽
    private Long inPeakBandWidth;// 输入流量带宽峰值
    private Long inBurstSize;// 输入流量突发大小
    private Boolean outTrafficEnabled;// 是否启用输出流量调整
    private Long outAverageBandWidth;// 输出流量平均带宽
    private Long outPeakBandWidth;// 输出流量带宽峰值
    private Long outBurstSize;// 输出流量突发大小
    private String policy;// 负载平衡
    private Boolean checkBeacon;// 网络故障切换检测
    private Boolean notifySwitches;// 通知交换机
    private Boolean rollingOrder;// 故障恢复
    private List<String> activeNics;// 活动适配器
    private List<String> standbyNics;// 备用适配器
    private Boolean ipfixEnabled;// NetFlow状态
    private List<String> activeUplinks;// 活动上行链路
    private List<String> standbyUplinks;// 备用上行链路
    private Boolean blocked;// 是否阻止所有端口
    private Boolean disconnectConfigReset;// 断开连接时配置重置
    private Boolean allowOverridePolicy;// 允许替代端口策略

    //fc 纳管
    private String uri;//访问该cluster对应的uri地址
    private Boolean isIpMacBind;//是否设置该端口组内的云主机的IP地址与MAC地址绑定，
    private Integer ipBcstSuppress;//广播抑制：0表示未开启
    private Boolean isCalcTcpCheckSum;//填充tcp校检和：false表示关闭
    private Boolean isDhcpIsolation;//dhcp隔离：false表示关闭
    private String vlanRange;
    private String switcherUri;//交换机uri，业务需要
    //fc 纳管

    public PortGroupModel() {
        super();
    }

    public PortGroupModel(String name, String type, Integer portNum, String groupVal, String remark) {
        super();
        this.name = name;
        this.type = type;
        this.portNum = portNum;
        this.groupVal = groupVal;
        this.remark = remark;
    }

    public PortGroupModel(String name, String type, Integer vlanId) {
        super();
        this.name = name;
        this.type = type;
        this.vlanId = vlanId;
    }
}
