package com.bocloud.cmp.service;


import com.bocloud.cmp.domain.DictionaryBean;
import com.bocloud.cmp.entity.Dictionary;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Result;

import java.util.List;

/**
 * 环境信息服务接口
 *
 * @author dmw
 */
public interface DictService {

    /**
     * 保存
     *
     * @param dictionary
     * @return
     */
    GeneralResult<Dictionary> create(Dictionary dictionary);

    /**
     * 删除
     *
     * @param id
     * @return
     */
    Result remove(Long id);

    /**
     * 修改
     *
     * @param bean
     * @return
     */
    GeneralResult<Dictionary> modify(DictionaryBean bean);

    /**
     * 字典树
     *
     * @param pid
     * @return
     */
    GeneralResult<List<Dictionary>> list(Long pid);

    /**
     * 根据值获取子节点数据
     *
     * @param pid
     * @return
     */
    GeneralResult<List<Dictionary>> listChild(String pid);

    /**
     * 查询字典树
     *
     * @param pid
     * @return
     */
    GeneralResult<List<Dictionary>> childTree(String pid);

}
