package com.bocloud.cmp.service;

import java.util.List;

import com.bocloud.cmp.entity.IpPool;
import com.bocloud.cmp.model.IpInfoModel;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;

public interface IpPoolService {

	/**
	 * 列表展示
	 *
	 * @param page
	 * @param rows
	 * @param params
	 * @param sorter
	 * @param simple
	 * @param condition
	 * @param user
	 * @return
	 */
	public GeneralResult<GridBean<IpPool>> list(Pager pager, RequestContext context);

	/**
	 * 创建
	 *
	 * @param params
	 * @param user
	 * @return
	 */
	public GeneralResult<IpPool> create(IpPool ipPool, RequestContext context);

	/**
	 * 修改
	 *
	 * @param params
	 * @param user
	 * @return
	 */
	public GeneralResult<IpPool> modify(IpPool ipPool, RequestContext context);

	/**
	 * 删除
	 *
	 * @param id
	 * @param user
	 * @return
	 */
	public GeneralResult remove(Long id, RequestContext context);

	/**
	 * 详情
	 *
	 * @param id
	 * @return
	 */
	public GeneralResult<IpPool> detail(Long id);
	
	
	GeneralResult<List<IpInfoModel>> ips(Long id, String cidr);

	GeneralResult listIpPoolByPoolGroupId(Integer page, Integer rows, String params, RequestContext context);

	public GeneralResult condition(String condition, RequestContext context);

}
