package com.bocloud.cmp.service;

import com.bocloud.cmp.entity.LoadBalancer;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;

/**
 * 负载均衡器service接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年9月4日
 */
public interface LoadBalancerService {

	/**
	 * 查询负载均衡器列表
	 *
	 * @param pager
	 * @param context
	 * @return
	 */
	GeneralResult<GridBean<LoadBalancer>> list(Pager pager, RequestContext context);

	/**
	 * 查询负载均衡器信息
	 *
	 * @param id
	 * @return
	 */
	GeneralResult<LoadBalancer> detail(Long id);

	GeneralResult labels(Long id, String labels, RequestContext context);

	GeneralResult listAvailableLbs(Long vendorId, String regionId, RequestContext context);


}
