package com.bocloud.cmp.service;

import com.bocloud.cmp.domain.AlterationParam;
import com.bocloud.cmp.domain.ApplicationParam;
import com.bocloud.cmp.domain.CancelationParam;
import com.bocloud.cmp.domain.ExtensionParam;
import com.bocloud.cmp.domain.OrderMessage;
import com.bocloud.cmp.enums.ResourceCategory;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.RequestContext;

/**
 * 资源申请处理服务
 *
 */
public interface PluginResourceOperationService {

	/**
	 * 资源申请
	 * 
	 * @param category
	 * @param param
	 * @param context
	 * @param operation
	 * @return
	 */
	GeneralResult application(ResourceCategory category, ApplicationParam applicationParam, RequestContext context,
			OrderMessage.Operation operation);

	/**
	 * 资源变更
	 * 
	 * @param category
	 * @param param
	 * @param context
	 * @param operation
	 * @return
	 */
	GeneralResult alteration(ResourceCategory category, AlterationParam alterationParam, RequestContext context,
			OrderMessage.Operation operation);

	/**
	 * 服务延期
	 * 
	 * @param category
	 * @param param
	 * @param context
	 * @param operation
	 * @return
	 */
	GeneralResult extension(ResourceCategory category, ExtensionParam extensionParam, RequestContext context,
			OrderMessage.Operation operation);

	/**
	 * 服务退订
	 * 
	 * @param category
	 * @param param
	 * @param context
	 * @param operation
	 * @return
	 */
	GeneralResult cancelation(ResourceCategory category, CancelationParam cancelationParam, RequestContext context,
			OrderMessage.Operation operation);

}
