package com.bocloud.cmp.service;

import com.bocloud.cmp.entity.VendorSyncRecord;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Result;

/**
 * @author admin
 */
public interface VendorSyncRecordService {

    /**
     * 列表
     *
     * @param pager
     * @return
     */
    GeneralResult<GridBean<VendorSyncRecord>> list(Pager pager);

    /**
     * 保存
     *
     * @param vendorSyncRecord
     * @return
     */
    Result save(VendorSyncRecord vendorSyncRecord);

    /**
     * 删除
     *
     * @param id
     * @return
     */
    Result remove(Long id);

    /**
     * 详情
     *
     * @param id
     * @return
     */
    GeneralResult<VendorSyncRecord> detail(Long id);

    /**
     * 根据云平台ID删除
     *
     * @param id
     * @return
     */
    Result removeByVendor(Long id);

    /**
     * 根据时间段删除
     *
     * @param startTime
     * @param endTime
     * @param vendorId
     * @return
     */
    Result removeByTime(String startTime, String endTime, Long vendorId);


}
