package com.bocloud.cmp.service.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.entity.ResourceModule;
import com.bocloud.cmp.entity.ResourceProperty;
import com.bocloud.cmp.repository.ResourcePropertyRepository;
import com.bocloud.cmp.service.ResourcePropertyService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.model.RequestContext;
import com.megatron.common.utils.Common;
import com.megatron.common.utils.GridHelper;
import com.google.common.collect.Maps;

import lombok.extern.slf4j.Slf4j;

/**
 * 平台类型 资源属性
 */
@Service("resourcePropertyService")
@Slf4j
public class ResourcePropertyServiceImpl implements ResourcePropertyService {

	@Autowired
	private ResourcePropertyRepository resourcePropertyRepository;

	@Override
	public GeneralResult<ResourceProperty> create(ResourceProperty resourceProperty, Long userId) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public GeneralResult<ResourceProperty> modify(ResourceProperty resourceProperty, Long userId) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public GeneralResult remove(Long id, Long userId) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public GeneralResult<GridBean<ResourceProperty>> list(Pager pager, RequestContext context) {
		List<Param> params = Optional.ofNullable(pager.getParams()).orElse(new ArrayList<>());
		Map<String, String> sorter = Optional.ofNullable(pager.getSorter()).orElse(Maps.newHashMap());
		sorter.put("gmtCreate", Common.ONE);
		Integer page = Optional.ofNullable(pager.getPage()).orElse(1);
		Integer rows = Optional.ofNullable(pager.getRows()).orElse(10);
		List<ResourceProperty> list = null;
		int total = 0;
		GridBean gridBean = null;
		try {
			total = this.resourcePropertyRepository.count(params);
			list = this.resourcePropertyRepository.list(page, rows, params, sorter);
			gridBean = GridHelper.getBean(page, rows, total, list);
			return new GeneralResult<>(true, gridBean, "查询成功");
		} catch (Exception e) {
			log.error("Query resource property  list fail:", e);
			return new GeneralResult<>(false, "查询失败", null, null);
		}
	}

	@Override
	public GeneralResult<ResourceProperty> detail(Long id) {
		// TODO Auto-generated method stub
		return null;
	}

}