package com.bocloud.cmp.service.impl;

import com.bocloud.cmp.entity.VolumePool;
import com.bocloud.cmp.repository.VolumePoolRepository;
import com.bocloud.cmp.repository.VolumeRepository;
import com.bocloud.cmp.service.VolumePoolService;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.DecimalFormat;
import java.util.List;
import java.util.Optional;

@Service("volumePoolService")
public class VolumePoolServiceImpl implements VolumePoolService {

    @Autowired
    private VolumePoolRepository volumePoolRepository;
    @Autowired
    private VolumeRepository volumeRepository;

    @Override
    public GeneralResult<GridBean<VolumePool>> list(Pager pager) {
        List<VolumePool> list = volumePoolRepository.list(pager);
        DecimalFormat decimalFormat = new DecimalFormat("######0.00");
        for (VolumePool pool : list) {
            Optional.ofNullable(pool.getCapacity()).map(decimalFormat::format).map(Double::valueOf).ifPresent(pool::setCapacity);
            Optional.ofNullable(pool.getUsedCapacity()).map(decimalFormat::format).map(Double::valueOf).ifPresent(pool::setUsedCapacity);
            pool.setVolumes(volumeRepository.listByPoolId(pool.getId()));
        }
        int total = volumePoolRepository.count(pager.getParams());
        GridBean<VolumePool> gridBean = new GridBean<>(pager.getPage(), pager.getRows(), total, list);
        return new GeneralResult<>(true, gridBean, "查询成功");
    }
}
